/*
 * Copyright (C) 2005-present, 58.com.  All rights reserved.
 * Use of this source code is governed by a BSD type license that can be
 * found in the LICENSE file.
 */

import 'package:fair/fair.dart';
import '../../model/bean/list_with_logic_bean.dart';
import 'package:flutter/material.dart';

@FairPatch()
class IfRangePage extends StatefulWidget {
  var fairProps;

  IfRangePage(dynamic data) {
    fairProps = data;
  }

  @override
  State<StatefulWidget> createState() {
    return _State();
  }
}

class _State extends State<IfRangePage> {
  @FairProps()
  var fairProps;

  var _list = [2, 4, 6, 8, 10];
  int _count = 0;

  String getTitle() {
    return fairProps['pageName'];
  }

  @override
  void initState() {
    super.initState();
    fairProps = widget.fairProps;
  }

  void onTapText() {
    _count = _count + 1;
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(getTitle()),
      ),
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Sugar.ifRange(_count, _list,
                falseValue: Image(
                  image: NetworkImage(
                      'http://pic1.58cdn.com.cn/nowater/jltx/n_v2952fbf1a46c342c48d950198878ec363.png'),
                ),
                trueValue: Image(
                  image: NetworkImage(
                      'http://pic1.58cdn.com.cn/nowater/jltx/n_v210e07e17f68c47c782aeeb4d57f4ad65.png'),
                )),
            Padding(
              padding: EdgeInsets.only(top: 20),
              child: Text('_count = $_count'),
            ),
            Padding(
              padding: EdgeInsets.only(top: 20),
              child: Text('_count in  2, 4, 6, 8, 10,  update image !'),
            ),
          ],
        ),
      ),
      floatingActionButton: Row(
        mainAxisAlignment: MainAxisAlignment.end,
        children: [
          FloatingActionButton(
            child: Icon(Icons.threesixty),
            onPressed: onTapText,
          )
        ],
      ),
    );
  }
}
